#pragma once
#define nWeps 5
#define nRes 3
#define objMax nWeps + nRes
#define nUnlocks 5
#include "Projectiles.h"

class Weapon
{
public:
	Weapon(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	virtual ~Weapon();
	
	void Fire( Coord coord );
	void Give(bool isGetting);
	bool IsUnlocked();
	bool Has();
	unsigned int GetCurrentUpgrade();
	std::string GetName();

	void Upgrade();
	void Downgrade();
	void Lock();
	void Unlock();
	int PurchasePrice();
	int SalePrice();
protected:
	void UpdateTimer(float *eventType);

	float fireRate, fireTimer;
	Projectile *projectileType;
	StateCore &core;
	// Weapon attributes
	Coord dummyPos;
	Coord dummySlope;
	float angle[ 5 ];
	const unsigned int nUpgrades;
	bool unlocked;
	bool have;
	unsigned int curlevel, nextLevel;
	std::string name;

};

class LaserWeap : public Weapon
{
public:
	LaserWeap(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~LaserWeap();
};

class MachineGun : public Weapon
{
public:
	MachineGun(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~MachineGun();
};

class ECannon : public Weapon
{
public:
	ECannon(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~ECannon();
};

class Blaster : public Weapon
{
public:
	Blaster(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);
	~Blaster();
};

class MLauncher : public Weapon
{
public:
	MLauncher(StateCore &core, bool unlock, bool have, unsigned int level, std::string name, unsigned int cost);	
	~MLauncher();

private:
	int maxMissiles, missileCount;
};